#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "error.h"
#include "errormessages.h" /* generated by gen_errorflags.sh, defines error messages for eachg error flag */

int ERRORSTATE=0;			/* single boolean indicating whether there were any errors */
char ERRORS[NERR] = {0};	/* zero initialized error flags */

void AddErr(int ERRFLAG)
{
	ERRORSTATE=1;
	if (ERRFLAG>NERR)
		fprintf(stderr, "ERROR: In Adderr() Error flag out of range!");
	else
		ERRORS[ERRFLAG]++;
}
int QueryErr(int ERRFLAG)
{
	if (ERRFLAG>NERR)
		fprintf(stderr, "ERROR: In QueryErr() Error flag out of range!");
	if (ERRORS[ERRFLAG])
		return 1;
	return 0;
}

void E_Messages()
{
	int i;
	for (i=1;i<NERR;i++)
		if (ERRORS[i])
			fprintf(stderr,"ERROR: %s (%dx)\n",  EMessages[i], ERRORS[i]);
}

/* as above, but return "; "-delimited string instead of stderr output */
char *E_Messages_str()
{
	int i;
	size_t slen = 0;
	char *s, *p;
	for (i=1;i<NERR;i++)
		if (ERRORS[i])
			slen += (size_t) snprintf(NULL, 0, "%s (%dx); ", EMessages[i], ERRORS[i]);
	s = p = (char *) malloc(slen + 1);
	*s = 0;
	for (i=1;i<NERR;i++)
		if (ERRORS[i])
			p += sprintf(p, "%s (%dx); ", EMessages[i], ERRORS[i]);
	if (p > s) *(p - 2) = 0; /* chomp trailing ; */
	return s;
}

void ResetErrors()
{
	int i;
	for (i=1;i<NERR;i++)
		ERRORS[i]=0;
	ERRORSTATE=0;
}
